
WScript.Echo "*********************************************"
WScript.Echo "cscript ListProvider.vbs"

On Error Resume Next
Set NamespaceSet = GetObject("WinMgmts://./root").InstancesOf ("__NAMESPACE")


WScript.Echo "============================================="
WScript.Echo 
WScript.Echo NamespaceSet.count & " WMI Namespaces existed on the local machine!"
WScript.Echo 
WScript.Echo "=============================================="

Dim ConnectionString
Dim ProviderCount
Dim ClassCount

ProviderCount = 0
ClassCount = 0

for each Namespace in NamespaceSet
	
	ConnectionString = "WinMgmts://./root/" & Namespace.Name
	
	Set ProviderSet = GetObject(ConnectionString ).InstancesOf ("__Win32Provider")
	WScript.Echo ProviderSet.count & " providers in //./root/" & Namespace.Name & " namespace:"
	WScript.Echo	
	for each Provider in ProviderSet
		WScript.Echo "    " & Provider.Name 
		WScript.Echo "    " & Provider.CLSID
		WScript.Echo	
		ProviderCount = ProviderCount + 1
	next

	Set objWMIService = GetObject(ConnectionString)
	Set colClasses = objWMIService.SubclassesOf()


	For Each objClass In colClasses
		ClassCount = ClassCount + 1
    		WScript.Echo objClass.Path_.Path
	Next

	WScript.Echo
	WScript.Echo	
	Set ProviderSet = Nothing
next

WScript.Echo	 "Total " & ProviderCount & " providers existed on local machine!"
WScript.Echo	 "Total " & ClassCount & " classes existed on local machine!"

If Err.Number <> 0 Then

	Wscript.Echo "Error " & Hex(Err.Number) & ", " & Err.Description

	Set LastError = createobject("wbemscripting.swbemlasterror")
	Wscript.Echo "Operation = " & LastError.operation & VBCRLF _
		& "ParameterInfo = " & LastError.ParameterInfo & VBCRLF _
		& "ProviderName = " & LastError.ProviderName	
		
	WScript.Quit (Err.Number)

End If

' Success, exit with code 0
WScript.Quit (0)
