
WScript.Echo "*********************************************"
WScript.Echo "cscript CIM_LogicalDevice.vbs"

On Error Resume Next
Set Service = GetObject("WinMgmts://./root/cimv2")

Set LogicalDeviceSet = Service.InstancesOf ("CIM_LogicalDevice2")

WScript.Echo LogicalDeviceSet.count & " logical devices found on the local machine:"
WScript.Echo "=============================================================================="
WScript.Echo 


for each LogicalDevice in LogicalDeviceSet 

	WScript.Echo "CreationClassName: " & LogicalDevice.CreationClassName
	WScript.Echo "Name:              " & LogicalDevice.Name 
	WScript.Echo "Description:       " & LogicalDevice.Description
	WScript.Echo "DeviceId:          " & LogicalDevice.DeviceId
	WScript.Echo "PNPDeviceId:       " & LogicalDevice.PNPDeviceId
	
	WScript.Echo 
next

WScript.Echo "=============================================================================="

If Err.Number <> 0 Then

	Wscript.Echo "Error " & Hex(Err.Number) & ", " & Err.Description

	Set LastError = createobject("wbemscripting.swbemlasterror")
	Wscript.Echo "Operation = " & LastError.operation & VBCRLF _
		& "ParameterInfo = " & LastError.ParameterInfo & VBCRLF _
		& "ProviderName = " & LastError.ProviderName	
		
	WScript.Quit (Err.Number)

End If

' Success, exit with code 0
WScript.Quit (0)
